]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
t/rebase: add failing tests for a peculiar revision
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
785063e0 12# But we protect ourselves from such a user mistake nevertheless.
365527ad
JH
13unset CDPATH
14
393050c3
JH
15# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
16# do not equate an unset IFS with IFS with the default, so here is
17# an explicit SP HT LF.
18IFS='
19'
785063e0 20
61dbb3c4
JH
21git_broken_path_fix () {
22 case ":$PATH:" in
23 *:$1:*) : ok ;;
24 *)
25 PATH=$(
26 SANE_TOOL_PATH="$1"
27 IFS=: path= sep=
28 set x $PATH
29 shift
30 for elem
31 do
32 case "$SANE_TOOL_PATH:$elem" in
33 (?*:/bin | ?*:/usr/bin)
34 path="$path$sep$SANE_TOOL_PATH"
35 sep=:
36 SANE_TOOL_PATH=
37 esac
38 path="$path$sep$elem"
39 sep=:
40 done
41 echo "$path"
42 )
43 ;;
44 esac
45}
46
47# @@BROKEN_PATH_FIX@@
0e0aea5a 48
adb231cf
FG
49die () {
50 die_with_status 1 "$@"
51}
52
53die_with_status () {
54 status=$1
55 shift
56 echo >&2 "$*"
57 exit "$status"
b33e9666
LT
58}
59
e064c170
SB
60GIT_QUIET=
61
62say () {
63 if test -z "$GIT_QUIET"
64 then
65 printf '%s\n' "$*"
66 fi
67}
68
bac199b7
PH
69if test -n "$OPTIONS_SPEC"; then
70 usage() {
5d292756
JH
71 "$0" -h
72 exit 1
bac199b7
PH
73 }
74
e817e3e8
PH
75 parseopt_extra=
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra="--keep-dashdash"
78
79 eval "$(
cbea86fd 80 echo "$OPTIONS_SPEC" |
e817e3e8
PH
81 git rev-parse --parseopt $parseopt_extra -- "$@" ||
82 echo exit $?
83 )"
bac199b7 84else
1b1dd23f 85 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 86 usage() {
0b54366c 87 die "usage: $dashless $USAGE"
bac199b7
PH
88 }
89
90 if [ -z "$LONG_USAGE" ]
91 then
0b54366c 92 LONG_USAGE="usage: $dashless $USAGE"
bac199b7 93 else
0b54366c 94 LONG_USAGE="usage: $dashless $USAGE
bac199b7
PH
95
96$LONG_USAGE"
97 fi
98
99 case "$1" in
87182b17 100 -h)
bac199b7
PH
101 echo "$LONG_USAGE"
102 exit
103 esac
104fi
d025524d 105
f9474132
SP
106set_reflog_action() {
107 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
108 then
109 GIT_REFLOG_ACTION="$*"
110 export GIT_REFLOG_ACTION
111 fi
112}
113
ef0c2abf 114git_editor() {
b4479f07
JN
115 if test -z "${GIT_EDITOR:+set}"
116 then
117 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
118 fi
119
120 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
121}
122
f6dff119
JN
123git_pager() {
124 if test -t 1
125 then
126 GIT_PAGER=$(git var GIT_PAGER)
127 else
128 GIT_PAGER=cat
129 fi
130 : ${LESS=-FRSX}
131 export LESS
132
133 eval "$GIT_PAGER" '"$@"'
134}
135
e1622bfc
JH
136sane_grep () {
137 GREP_OPTIONS= LC_ALL=C grep "$@"
138}
139
140sane_egrep () {
141 GREP_OPTIONS= LC_ALL=C egrep "$@"
142}
143
4b441f47 144is_bare_repository () {
5be60078 145 git rev-parse --is-bare-repository
4b441f47
JH
146}
147
9fde9401 148cd_to_toplevel () {
91dc602d
SD
149 cdup=$(git rev-parse --show-toplevel) &&
150 cd "$cdup" || {
151 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
152 exit 1
153 }
9fde9401
JH
154}
155
e2eb5273
JH
156require_work_tree_exists () {
157 if test "z$(git rev-parse --is-bare-repository)" != zfalse
158 then
159 die "fatal: $0 cannot be used without a working tree."
160 fi
161}
162
7eff28a9 163require_work_tree () {
ab62677b 164 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
7eff28a9
SP
165 die "fatal: $0 cannot be used without a working tree."
166}
167
92c62a3f
RR
168require_clean_work_tree () {
169 git rev-parse --verify HEAD >/dev/null || exit 1
170 git update-index -q --ignore-submodules --refresh
171 err=0
172
173 if ! git diff-files --quiet --ignore-submodules
174 then
175 echo >&2 "Cannot $1: You have unstaged changes."
176 err=1
177 fi
178
179 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
180 then
181 if [ $err = 0 ]
182 then
183 echo >&2 "Cannot $1: Your index contains uncommitted changes."
184 else
185 echo >&2 "Additionally, your index contains uncommitted changes."
186 fi
187 err=1
188 fi
189
190 if [ $err = 1 ]
191 then
192 test -n "$2" && echo >&2 "$2"
193 exit 1
194 fi
195}
196
ce80ca56
JK
197# Generate a sed script to parse identities from a commit.
198#
199# Reads the commit from stdin, which should be in raw format (e.g., from
200# cat-file or "--pretty=raw").
201#
202# The first argument specifies the ident line to parse (e.g., "author"), and
203# the second specifies the environment variable to put it in (e.g., "AUTHOR"
204# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
205# committer.
206pick_ident_script () {
207 while test $# -gt 0
208 do
209 lid=$1; shift
210 uid=$1; shift
211 printf '%s' "
212 /^$lid /{
213 s/'/'\\\\''/g
214 h
215 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
216 s/.*/GIT_${uid}_NAME='&'/p
217
218 g
219 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
220 s/.*/GIT_${uid}_EMAIL='&'/p
221
222 g
223 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
224 s/.*/GIT_${uid}_DATE='&'/p
225 }
226 "
227 done
228 echo '/^$/q'
229}
230
231# Create a pick-script as above and feed it to sed. Stdout is suitable for
232# feeding to eval.
233parse_ident_from_commit () {
234 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
235}
236
237# Parse the author from a commit given as an argument. Stdout is suitable for
238# feeding to eval to set the usual GIT_* ident variables.
0cae2346 239get_author_ident_from_commit () {
0cae2346 240 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 241 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
ce80ca56 242 parse_ident_from_commit author AUTHOR
0cae2346
JS
243}
244
7d750f0e
GB
245# Clear repo-local GIT_* environment variables. Useful when switching to
246# another repository (e.g. when entering a submodule). See also the env
247# list in git_connect()
248clear_local_git_env() {
249 unset $(git rev-parse --local-env-vars)
250}
251
4549162e
KB
252# Generate a virtual base file for a two-file merge. Uses git apply to
253# remove lines from $1 that are not in $2, leaving only common lines.
254create_virtual_base() {
255 sz0=$(wc -c <"$1")
256 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
257 sz1=$(wc -c <"$1")
258
259 # If we do not have enough common material, it is not
260 # worth trying two-file merge using common subsections.
261 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
262}
263
87bddba9 264
10587ce6 265# Platform specific tweaks to work around some commands
87bddba9
JS
266case $(uname -s) in
267*MINGW*)
268 # Windows has its own (incompatible) sort and find
269 sort () {
270 /usr/bin/sort "$@"
271 }
272 find () {
273 /usr/bin/find "$@"
274 }
be39048a
RJ
275 # git sees Windows-style pwd
276 pwd () {
277 builtin pwd -W
278 }
5e9677cb
PT
279 is_absolute_path () {
280 case "$1" in
281 [/\\]* | [A-Za-z]:*)
282 return 0 ;;
283 esac
284 return 1
285 }
87bddba9 286 ;;
5e9677cb
PT
287*)
288 is_absolute_path () {
289 case "$1" in
290 /*)
291 return 0 ;;
292 esac
293 return 1
294 }
87bddba9 295esac
10587ce6
JH
296
297# Make sure we are in a valid repository of a vintage we understand,
298# if we require to be in a git repository.
299if test -z "$NONGIT_OK"
300then
301 GIT_DIR=$(git rev-parse --git-dir) || exit
302 if [ -z "$SUBDIRECTORY_OK" ]
303 then
304 test -z "$(git rev-parse --show-cdup)" || {
305 exit=$?
306 echo >&2 "You need to run this command from the toplevel of the working tree."
307 exit $exit
308 }
309 fi
310 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
311 echo >&2 "Unable to determine absolute path of git directory"
312 exit 1
313 }
314 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
315fi